import java.util.ArrayList;

/**
 * Die Klasse Controller
 * verwaltet das Projekt
 * 
 * @author claus albowski
 * @version 5'2015
 */
public class Controller
{
    private ArrayList<Stueck> stuecke, reste;
    private Container container;
    
    /**
     * Konstruktor fuer Objekte der Klasse Controller
     */
    public Controller()
    {
        stuecke = new ArrayList();
        reste = new ArrayList();
    }
    
    /**
     * erzeugt einen neuen Container
     */
    public void neuerContainer(int fassungsvermoegen){
        container = new Container(fassungsvermoegen);
    }

    /**
     * erzeugt ein neues Stueck
     */
    public void neuesStueck(int volumen){
        stuecke.add(new Stueck(volumen));
    }

    /**
     * fuellt den Container nach dem greedy Verfahren
     */
    public boolean fuelleGreedy()
    {
        for (Stueck stueck: stuecke) 
        if (!container.fuelleEin(stueck)) reste.add(stueck);
        return container.istVoll();
    }
    
    /**
     * fuellt einen Container durch Tiefensuche mit backtracking;
     * die Alternativen auf jeder Stufe des binaeren Baumes
     * sind das Stuecke einzufuellen oder nicht;
     * der Zugriff auf die Stuecke erfolgt ueber den Index
     * diese Methode ruft nur die private rekursive Methode auf.
     */
    public boolean fuelleTS()
    {
        fuelleTS(0, container);
        for (Stueck stueck : stuecke)
        if (!container.gibStuecke().contains(stueck)) reste.add(stueck);
        return container.istVoll();
    }
    private void fuelleTS(int i, Container aktuell)
    {
        if ((aktuell.gibFuellung() >= container.gibFuellung())
        && (aktuell.gibFuellung() <= container.gibGroesse()))
        container = aktuell; // besten sichern
        if (aktuell.istVoll()) return;
        if (i==stuecke.size())  return; // keine Stuecke mehr
        Container aktuellMitStueck = new Container(aktuell);
        if (aktuellMitStueck.fuelleEin(stuecke.get(i))) // geht es hinein?
        fuelleTS(i+1, aktuellMitStueck);
        fuelleTS(i+1, aktuell);
    }
    
    /**
     * zeigt das Ergebnis an.
     */
    public void zeigeErgebnis(){
        System.out.println("Der Container mit dem Fassungsvermoegen: "+container.gibGroesse()+" enthaelt: ");
        for (Stueck stueck : container.gibStuecke()) System.out.print(stueck.gibGroesse()+" ");
        System.out.println();
        if (container.istVoll()) System.out.println("Er ist vollstaendig gefuellt.\n");
        else System.out.println("Er konnte nicht vollstaendig gefuellt werden.\n");
    }
}
